<?php
/**
 * InlineResponse20146Content
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineResponse20146Content Class Doc Comment
 *
 * @category Class
 * @description infos about the created \&quot;tanss event\&quot;
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineResponse20146Content implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_response_201_46_content';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'employeeId' => 'int',
        'linkType' => 'object',
        'linkId' => 'int',
        'triggerType' => 'string',
        'content' => '\SLIS\Adapter\Tanss\Model\InlineResponse20146ContentContent'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'id' => null,
        'employeeId' => null,
        'linkType' => null,
        'linkId' => null,
        'triggerType' => null,
        'content' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'employeeId' => 'employeeId',
        'linkType' => 'linkType',
        'linkId' => 'linkId',
        'triggerType' => 'triggerType',
        'content' => 'content'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'employeeId' => 'setEmployeeId',
        'linkType' => 'setLinkType',
        'linkId' => 'setLinkId',
        'triggerType' => 'setTriggerType',
        'content' => 'setContent'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'employeeId' => 'getEmployeeId',
        'linkType' => 'getLinkType',
        'linkId' => 'getLinkId',
        'triggerType' => 'getTriggerType',
        'content' => 'getContent'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    public const TRIGGER_TYPE_STATUS_CHANGED = 'TICKET_STATUS_CHANGED';
    public const TRIGGER_TYPE_ASSIGNED_TO_ANOTHER_TECHNICIAN = 'TICKET_ASSIGNED_TO_ANOTHER_TECHNICIAN';
    public const TRIGGER_TYPE_NEW_COMMENT = 'TICKET_NEW_COMMENT';
    public const TRIGGER_TYPE_NEW_SUPPORT = 'TICKET_NEW_SUPPORT';
    public const TRIGGER_TYPE_CREATED = 'TICKET_CREATED';
    public const TRIGGER_TYPE_REMINDER = 'TICKET_REMINDER';
    public const TRIGGER_TYPE_EMAIL_RECEIVED = 'TICKET_EMAIL_RECEIVED';
    public const TRIGGER_TYPE_NOT_MORE_ASSIGNED_TO_SELF = 'TICKET_NOT_MORE_ASSIGNED_TO_SELF';
    public const TRIGGER_TYPE_NEW_SERVICE_CAP = 'TICKET_NEW_SERVICE_CAP';
    public const TRIGGER_TYPE_CLOSED = 'TICKET_CLOSED';
    public const TRIGGER_TYPE_NEW_DUE_DATE = 'TICKET_NEW_DUE_DATE';
    public const TRIGGER_TYPE_NEW_DEADLINE = 'TICKET_NEW_DEADLINE';
    public const TRIGGER_TYPE_RESUBMISSION_HIT = 'TICKET_RESUBMISSION_HIT';
    public const TRIGGER_TYPE_TAGS_CHANGED = 'TICKET_TAGS_CHANGED';

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getTriggerTypeAllowableValues()
    {
        return [
            self::TRIGGER_TYPE_STATUS_CHANGED,
            self::TRIGGER_TYPE_ASSIGNED_TO_ANOTHER_TECHNICIAN,
            self::TRIGGER_TYPE_NEW_COMMENT,
            self::TRIGGER_TYPE_NEW_SUPPORT,
            self::TRIGGER_TYPE_CREATED,
            self::TRIGGER_TYPE_REMINDER,
            self::TRIGGER_TYPE_EMAIL_RECEIVED,
            self::TRIGGER_TYPE_NOT_MORE_ASSIGNED_TO_SELF,
            self::TRIGGER_TYPE_NEW_SERVICE_CAP,
            self::TRIGGER_TYPE_CLOSED,
            self::TRIGGER_TYPE_NEW_DUE_DATE,
            self::TRIGGER_TYPE_NEW_DEADLINE,
            self::TRIGGER_TYPE_RESUBMISSION_HIT,
            self::TRIGGER_TYPE_TAGS_CHANGED,
        ];
    }

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['id'] = $data['id'] ?? null;
        $this->container['employeeId'] = $data['employeeId'] ?? null;
        $this->container['linkType'] = $data['linkType'] ?? null;
        $this->container['linkId'] = $data['linkId'] ?? null;
        $this->container['triggerType'] = $data['triggerType'] ?? null;
        $this->container['content'] = $data['content'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        $allowedValues = $this->getTriggerTypeAllowableValues();
        if (!is_null($this->container['triggerType']) && !in_array($this->container['triggerType'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'triggerType', must be one of '%s'",
                $this->container['triggerType'],
                implode("', '", $allowedValues)
            );
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int|null
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int|null $id id
     *
     * @return self
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets employeeId
     *
     * @return int|null
     */
    public function getEmployeeId()
    {
        return $this->container['employeeId'];
    }

    /**
     * Sets employeeId
     *
     * @param int|null $employeeId id of the employee who this event is for
     *
     * @return self
     */
    public function setEmployeeId($employeeId)
    {
        $this->container['employeeId'] = $employeeId;

        return $this;
    }

    /**
     * Gets linkType
     *
     * @return object|null
     */
    public function getLinkType()
    {
        return $this->container['linkType'];
    }

    /**
     * Sets linkType
     *
     * @param object|null $linkType linkType
     *
     * @return self
     */
    public function setLinkType($linkType)
    {
        $this->container['linkType'] = $linkType;

        return $this;
    }

    /**
     * Gets linkId
     *
     * @return int|null
     */
    public function getLinkId()
    {
        return $this->container['linkId'];
    }

    /**
     * Sets linkId
     *
     * @param int|null $linkId id of the assignment, which this event refers to
     *
     * @return self
     */
    public function setLinkId($linkId)
    {
        $this->container['linkId'] = $linkId;

        return $this;
    }

    /**
     * Gets triggerType
     *
     * @return string|null
     */
    public function getTriggerType()
    {
        return $this->container['triggerType'];
    }

    /**
     * Sets triggerType
     *
     * @param string|null $triggerType describes the \"trigger type\" of an event
     *
     * @return self
     */
    public function setTriggerType($triggerType)
    {
        $allowedValues = $this->getTriggerTypeAllowableValues();
        if (!is_null($triggerType) && !in_array($triggerType, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'triggerType', must be one of '%s'",
                    $triggerType,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['triggerType'] = $triggerType;

        return $this;
    }

    /**
     * Gets content
     *
     * @return \SLIS\Adapter\Tanss\Model\InlineResponse20146ContentContent|null
     */
    public function getContent()
    {
        return $this->container['content'];
    }

    /**
     * Sets content
     *
     * @param \SLIS\Adapter\Tanss\Model\InlineResponse20146ContentContent|null $content content
     *
     * @return self
     */
    public function setContent($content)
    {
        $this->container['content'] = $content;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


